Coin: SoMField Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoMField Class Referenceabstract
Field Classes

The SoMField class is the base class for fields which can contain multiple values. More...

`#include <Inventor/fields/SoMField.h>`

Inheritance diagram for SoMField:

## Public Member Functions
virtual | ~SoMField ()
int | getNum (void) const
void | setNum (const int num)
virtual void | deleteValues (int start, int num=-1)
virtual void | insertSpace (int start, int num)
SbBool | set1 (const int index, const char *const valuestring)
void | get1 (const int index, SbString &valuestring)
virtual void | enableDeleteValues (void)
virtual SbBool | isDeleteValuesEnabled (void) const
Public Member Functions inherited from SoField
virtual | ~SoField ()
void | setIgnored (SbBool ignore)
SbBool | isIgnored (void) const
void | setDefault (SbBool defaultVal)
SbBool | isDefault (void) const
virtual SoType | getTypeId (void) const =0
SbBool | isOfType (const SoType type) const
void | enableConnection (SbBool flag)
SbBool | isConnectionEnabled (void) const
SbBool | connectFrom (SoEngineOutput *master, SbBool notnotify=FALSE, SbBool append=FALSE)
SbBool | appendConnection (SoEngineOutput *master, SbBool notnotify=FALSE)
void | disconnect (SoEngineOutput *engineoutput)
SbBool | isConnectedFromEngine (void) const
SbBool | getConnectedEngine (SoEngineOutput *&master) const
SbBool | connectFrom (SoField *master, SbBool notnotify=FALSE, SbBool append=FALSE)
SbBool | appendConnection (SoField *master, SbBool notnotify=FALSE)
void | disconnect (SoField *field)
SbBool | isConnectedFromField (void) const
SbBool | getConnectedField (SoField *&master) const
int | getNumConnections (void) const
int | getForwardConnections (SoFieldList &slavelist) const
int | getConnections (SoFieldList &masterlist) const
void | disconnect (void)
SbBool | isConnected (void) const
void | setContainer (SoFieldContainer *cont)
SoFieldContainer * | getContainer (void) const
SbBool | set (const char *valuestring)
void | get (SbString &valuestring)
SbBool | shouldWrite (void) const
virtual void | touch (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *nlist)
SbBool | enableNotify (SbBool on)
SbBool | isNotifyEnabled (void) const
void | addAuditor (void *f, SoNotRec::Type type)
void | removeAuditor (void *f, SoNotRec::Type type)
int | operator== (const SoField &f) const
int | operator!= (const SoField &f) const
virtual void | connectionStatusChanged (int numconnections)
SbBool | isReadOnly (void) const
virtual SbBool | isSame (const SoField &f) const =0
virtual void | copyFrom (const SoField &f)=0
virtual void | fixCopy (SbBool copyconnections)
virtual SbBool | referencesCopy (void) const
void | copyConnection (const SoField *fromfield)
virtual SbBool | read (SoInput *input, const SbName &name)
virtual void | write (SoOutput *out, const SbName &name) const
virtual void | countWriteRefs (SoOutput *out) const
void | setFieldType (int type)
int | getFieldType (void) const
SbBool | getDirty (void) const
void | setDirty (SbBool dirty)
void | evaluate (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | atexit_cleanup (void)
static void | initClass (void)
Static Public Member Functions inherited from SoField
static void | initClass (void)
static void | initClasses (void)
static void | cleanupClass (void)
static SoType | getClassTypeId (void)

## Protected Member Functions
| SoMField (void)
virtual void | makeRoom (int newnum)
virtual SoNotRec | createNotRec (SoBase *container)
void | setChangedIndex (const int chgidx)
void | setChangedIndices (const int chgidx=-1, const int numchgind=0)
Protected Member Functions inherited from SoField
| SoField (void)
void | valueChanged (SbBool resetdefault=TRUE)
virtual void | evaluateConnection (void) const
virtual SbBool | readConnection (SoInput *in)
virtual void | writeConnection (SoOutput *out) const
SbBool | isDestructing (void) const

## Protected Attributes
int | num
int | maxNum
SbBool | userDataIsUsed

## Additional Inherited Members
Public Types inherited from SoField
enum | FieldType { NORMAL_FIELD = 0 , EVENTIN_FIELD , EVENTOUT_FIELD , EXPOSED_FIELD }

## Detailed Description

The SoMField class is the base class for fields which can contain multiple values.

All field types which may contain more than one member value inherits this class. SoMField is an abstract class.

Use setValue(), setValues() or set1Value() to set the values of fields inheriting SoMField, and use getValues() or the index operator [] to read values. Example code:

SoText2 * textnode = new SoText2;
textnode->ref();
// Setting multi-field values. /////////////////////////////
// Set the first value of the SoMFString field of the SoText2 node.
// The field array will be truncated to only contain this single value.
textnode->string.setValue("Morten");
// Full contents of the SoMFString is: [ "Morten" ]
// The setValue() method and the = operator is interchangeable,
// so this code line does the same as the previous line.
textnode->string = "Peder";
// Full contents of the SoMFString is now: [ "Peder" ]
// Set the value at index 2. If the field value array contained
// less than 3 elements before this call, first expand it to contain
// 3 elements.
textnode->string.set1Value(2, "Lars");
// Full contents of the SoMFString is: [ "Peder", <undefined>, "Lars" ]
// This sets 3 values of the array, starting at index 5. If the
// array container had less than 8 elements before the setValues()
// call, the array will first be expanded.
SbString s[3] = { "Eriksen", "Blekken", "Aas" };
textnode->string.setValues(5, sizeof(s) / sizeof(s[0]), s);
// Full contents of the SoMFString is now:
// [ "Peder", <undefined>, "Lars", <undefined>, <undefined>,
// "Eriksen", "Blekken", "Aas" ]
// Note also that the setValues() call will *not* truncate a field
// container if you use it to change a subset at the start:
SbString n[4] = { "Dixon", "Adams", "Bould", "Winterburn" };
textnode->string.setValues(0, sizeof(n) / sizeof(n[0]), n);
// Full contents of the SoMFString is now:
// [ "Dixon", "Adams", "Bould", "Winterburn", <undefined>,
// "Eriksen", "Blekken", "Aas" ]
// Inspecting multi-field values. //////////////////////////
// This will read the second element (counting from zero) if the
// multivalue field and place it in "val".
SbString val = textnode->string[2];
// Gives us a pointer to the array which the multiple-value field
// is using to store the values. Note that the return value is
// "const", so you can only read from the array, not write to
// it.
const SbString * vals = textnode->string.getValues(0);
// Modifying multi-field values. ///////////////////////////
// You can of course modify multifield-values by using the set-
// and get-methods shown above, but when you're working with
// big sets of data, this will be ineffective. Then use this
// technique instead:
SbString * modvals = textnode->string.startEditing();
// ... lots of modifications to the "modvals" array here ...
// Calling the finishEditing() method is necessary for the
// scene graph to be updated (and re-rendered).
textnode->string.finishEditing();
SbString
The SbString class is a string class with convenience functions for string operations.
Definition SbString.h:52
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoMFString::getValues
const SbString * getValues(const int start) const
Definition SoMFString.h:43
SoText2
The SoText2 class is a node type for visualizing 2D text aligned with the camera plane.
Definition SoText2.h:42
SoText2::string
SoMFString string
Definition SoText2.h:57

The reason it is more effective to wrap many modifications within startEditing() / finishEditing() is because we avoid the stream of notification messages which would otherwise be sent for each and every modification done. Instead there will just be a single notification about the changes, triggered by the finishEditing() call.

The correct manner in which to pre-allocate a specific number of field values in one chunk is to use the SoMField::setNum() method, for instance in advance of using the startEditing() and finishEditing() methods. The field values will be uninitialized after expanding the field with the setNum() call.

Be aware that your application code must be careful to not do silly things during a setValues()-triggered notification. If you have code that looks for instance like this:

// update set of coordinate indices at the start of e.g.
// an SoIndexedFaceSet's coordIndex field..
ifs->coordIndex.setValues(0, runner->numIndices, runner->indices);
// ..then truncate to make sure it's the correct size.
ifs->coordIndex.setNum(runner->numIndices);

As setValues() might leave some elements at the end of the array that typically can be invalid indices after the first statement is executed, something can go wrong during notification if you have application code monitoring changes, and the application code then for instance triggers an action or something that tries to use the coordIndex field before it is updated to its correct size with the setNum() call.

(Notification can in this case, as always, be temporarily disabled to be on the safe side:

somefield.enableNotify(FALSE);
somefield.setValues(...);
somefield.setNum(...);
somefield.enableNotify(TRUE);
somefield.touch();

This will guarantee that the setValues() and setNum() pair will be executed as an atomic operation.)

When nodes, engines or other types of field containers are written to file, their multiple-value fields are written to file in this format:

containerclass {
fieldname [ value0, value1, value2, ...]
...
}

..like this, for instance, a Coordinate3 node providing 6 vertex coordinates in the form of SbVec3f values in its "point" field for e.g. a faceset, lineset or pointset:

Coordinate3 {
point [
-1 1 0, -1 -1 0, 1 -1 0,
0 2 -1, -2 0 -1, 0 -2 -1,
]
}

Some fields support application data sharing through a setValuesPointer() method. setValuesPointer() makes it possible to set the data pointer directly in the field. Normally (when using setValues()), Coin makes a copy of your data, so this method can be very useful if your application needs the data internally and you're just using Coin for the visualization. Example code:

myapp->calculateCoordinates(SOME_LARGE_VALUE);
SbVec3f * mycoords = myapp->getCoordinates();
SoCoordinate3 * mynode = myapp->getCoordinateNode();
mynode->point.setValuesPointer(SOME_LARGE_VALUE, mycoords);
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51
SoCoordinate3
The SoCoordinate3 class is a node for providing coordinates to shape nodes.
Definition SoCoordinate3.h:41
SoCoordinate3::point
SoMFVec3f point
Definition SoCoordinate3.h:50

Be aware that your field should be a read-only field when you set the data like this. If you write to the field, the values in your application array will be overwritten. If you append values to the field, a new array will be allocated, and the data will be copied into it before appending the new values. The array pointer will then be discarded.

Also note that whenever you change some value(s) in the array, you must manually notify Coin about this by calling SoField::touch(). For our example:

SbVec3f * mycoords = myapp->getCoordinate();
myapp->updateCoordinate(mycoords);
SoCoordinate3 * mynode = myapp->getCoordinateNode();
mynode->point.touch(); // this will notify Coin that field has changed
SoField::touch
virtual void touch(void)
Definition SoField.cpp:1427

You can use SoMField::enableDeleteValues() to make Coin delete the array for you when the field is destructed or the array pointer is discarded because it isn't needed anymore (e.g. when the array size is changed). The array will be deleted using the C++ delete[] operator, so if you use it, your array must be allocated using the C++ new[] operator.

SoMField::enableDeleteValues() is supported only to be compatible with later versions of TGS Inventor and we don't recommend using it. It can have undefined results on the Microsoft Windows platform. Allocating memory in the application and destructing it in a DLL can be a bad thing, causing mysterious crashes, if you're not very careful about how your application and DLLs are linked to the underlying C library.

See also
  SoSField

## Constructor & Destructor Documentation

## ◆ ~SoMField()

SoMField::~SoMField | ( |  | ) |
| virtual

Destructor in SoMField does nothing. Resource deallocation needs to be done from subclasses.

## ◆ SoMField()

SoMField::SoMField | ( | void |  | ) |
| protected

Constructor. Initializes number of values in field to zero.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoMField::getClassTypeId | ( | void |  | ) |
| static

Returns a unique type identifier for this field class.

See also
  getTypeId(), SoType

## ◆ getNum()

int SoMField::getNum | ( | void |  | ) | const
| inline

Returns number of values in this field.

## ◆ setNum()

void SoMField::setNum | ( | const int | numarg | ) |

Set number of values to num.

If the current number of values is larger than num, the array of values will be truncated from the end. But if num is larger, the array will automatically be expanded (and random values will be set for the new array items).

## ◆ deleteValues()

void SoMField::deleteValues | ( | int | start,
|  | int | numarg = -1 )
| virtual

Remove value elements from index start up to and including index start + num - 1.

Elements with indices larger than the last deleted element will be moved downwards in the value array.

If num equals -1, delete from index start and to the end of the array.

Reimplemented in SoMFEngine, SoMFNode, and SoMFPath.

## ◆ insertSpace()

void SoMField::insertSpace | ( | int | start,
|  | int | numarg )
| virtual

Insert num "slots" for new value elements from start. The elements already present from start will be moved "upward" in the extended array.

Reimplemented in SoMFEngine, SoMFNode, and SoMFPath.

## ◆ set1()

SbBool SoMField::set1 | ( | const int | index,
|  | const char *const | valuestring )

Set the value at index to the value contained in valuestring. Returns `TRUE` if a valid value for this field can be extracted from valuestring, otherwise `FALSE`.

If index is larger than the current number of elements in the field, this method will automatically expand the field to accommodate the new value.

## ◆ get1()

void SoMField::get1 | ( | const int | index,
|  | SbString & | valuestring )

Return the value at index in the valuestring string.

## ◆ initClass()

void SoMField::initClass | ( | void |  | ) |
| static

Internal method called upon initialization of the library (from SoDB::init()) to set up the type system.

## ◆ enableDeleteValues()

void SoMField::enableDeleteValues | ( | void |  | ) |
| virtual

Can be used to make Coin delete the array pointer set through a setValuesPointer() call. See SoMField documentation for information about the setValuesPointer() function.

This method is a TGS extension (introduced in TGS OIV v3.0) and is supported only for compatibility. We suggest that you don't use it since it can lead to hard-to-find bugs.

Since
  Coin 2.0
  TGS Inventor 3.0

## ◆ isDeleteValuesEnabled()

SbBool SoMField::isDeleteValuesEnabled | ( | void |  | ) | const
| virtual

Returns whether SoMField::enableDeleteValues() has been called on a field. The result is only valid if setValuesPointer() has been called on the field first.

This method is a TGS extension (introduced in TGS OIV v3.0) and is supported only for compatibility. We suggest that you don't use it since it can lead to hard-to-find bugs.

Since
  Coin 2.0
  TGS Inventor 3.0

## ◆ makeRoom()

void SoMField::makeRoom | ( | int | newnum | ) |
| protectedvirtual

Make room in the field to store newnum values.

## ◆ createNotRec()

SoNotRec SoMField::createNotRec | ( | SoBase * | container | ) |
| protectedvirtual

Reimplemented from SoField.

## Member Data Documentation

## ◆ num

int SoMField::num
| protected

Number of available values.

## ◆ maxNum

int SoMField::maxNum
| protected

Number of array "slots" allocated for this field.

## ◆ userDataIsUsed

SbBool SoMField::userDataIsUsed
| protected

Is `TRUE` if data have been set through a setValuesPointer() call and set to `FALSE` through a enableDeleteValues() call.

The documentation for this class was generated from the following files:

- SoMField.h
- SoMField.cpp